// DirInputTesterDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DirInputTester.h"
#include "DirInputTesterDlg.h"
#include "DirInput.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

BOOL IS_CONSTANT = FALSE;
/////////////////////////////////////////////////////////////////////////////
// CDirInputTesterDlg dialog

CDirInputTesterDlg::CDirInputTesterDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDirInputTesterDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDirInputTesterDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDirInputTesterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDirInputTesterDlg)
	DDX_Control(pDX, IDC_PHASE, myPhaseSlider);
	DDX_Control(pDX, IDC_PERIOD, myPeriodSlider);
	DDX_Control(pDX, IDC_OFFSET, myOffsetSlider);
	DDX_Control(pDX, IDC_MAGNITUDE, myMagnitudeSlider);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDirInputTesterDlg, CDialog)
	//{{AFX_MSG_MAP(CDirInputTesterDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_HSCROLL()
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_START_FORCE, OnStartForce)
	ON_BN_CLICKED(IDC_STOP_FORCE, OnStopForce)
	ON_BN_CLICKED(IDC_CONST_FORCE, OnConstForce)
	ON_BN_CLICKED(IDC_STOP_C_FORCE, OnStopCForce)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDirInputTesterDlg message handlers

BOOL CDirInputTesterDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	if( !CaptureFFdevice( GetSafeHwnd( ) ) ){
        MessageBox(TEXT("Error Initializing DirectInput"), TEXT("DirectInput Tester"), MB_ICONERROR | MB_OK );
        EndDialog( 0 );
		return FALSE;
	}
	// Set a timer to go off 30 times a second. At every timer message
    // the input device will be read
    ::SetTimer( GetSafeHwnd( ), 0, 1000 / 30, NULL );
	if(JOYSTICK == GetDeviceType( )){
		(GetDlgItem(IDC_DEV_TYPE))->SetWindowText("JOYSTICK");
		(GetDlgItem(IDC_A_AXIS_TEXT))->SetWindowText("Rudder:");
		(GetDlgItem(IDC_B_AXIS_TEXT))->SetWindowText("Throttle:");
		(GetDlgItem(IDC_SLIDER_TEXT))->ShowWindow(SW_HIDE);
		(GetDlgItem(IDC_SLIDER))->ShowWindow(SW_HIDE);
		(GetDlgItem(IDC_OFFSET_X_FORCE))->SetWindowText("X Axis Force:");
		(GetDlgItem(IDC_DIR_Y_FORCE))->SetWindowText("Y Axis Force:");
		myPeriodSlider.SetRange(4,20,FALSE);
		myPhaseSlider.SetRange(-10000,10000,FALSE);
		CreateConstantForce(0, 0);
	}
	else if(GAMEPAD == GetDeviceType( )){
	(GetDlgItem(IDC_DEV_TYPE))->SetWindowText("GAMEPAD");
    (GetDlgItem(IDC_STOP_C_FORCE))->ShowWindow(SW_HIDE);
	(GetDlgItem(IDC_CONST_FORCE))->ShowWindow(SW_HIDE);
	myPeriodSlider.SetRange(0,1000,FALSE);
	myPhaseSlider.SetRange(0,35999,FALSE);
	}
	else{
		MessageBox(TEXT("Found unknown device. Program terminates!"), TEXT("DirectInput Tester"), MB_ICONERROR | MB_OK );
        EndDialog( 0 );
		return FALSE;
	}
	SetupPeriodicForce( );
	myOffsetSlider.SetRange(-10000,10000,FALSE);
	myMagnitudeSlider.SetRange(0,10000,FALSE);
	
	TCHAR       strText[128]; 
	wsprintf( strText, TEXT("%ld"), myMagnitudeSlider.GetRangeMin( )); 
	(GetDlgItem(IDC_SLIDER_VAL))->SetWindowText(strText);
	wsprintf( strText, TEXT("%ld"), myPhaseSlider.GetRangeMin( ) ); 
	(GetDlgItem(IDC_PHASE_VAL))->SetWindowText(strText);
	//Convert double value from period slider to CString;
	CString strValue;
	double dValue= 0.01*(double)myPeriodSlider.GetPos( );
	strValue.Format("%.2f",dValue);
	(GetDlgItem(IDC_PERIOD_VAL))->SetWindowText(strValue);
	wsprintf( strText, TEXT("%ld"), myOffsetSlider.GetRangeMin( ) ); 
	(GetDlgItem(IDC_OFFSET_VAL))->SetWindowText(strText);
	myMagnitudeSlider.SetPos(myMagnitudeSlider.GetRangeMin( ));
	myPhaseSlider.SetPos(myPhaseSlider.GetRangeMin( ));
	myPeriodSlider.SetPos(myPeriodSlider.GetRangeMin( ));
	myOffsetSlider.SetPos(myOffsetSlider.GetRangeMin( ));


	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDirInputTesterDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDirInputTesterDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}



void CDirInputTesterDlg::OnDestroy() 
{
	::KillTimer( GetSafeHwnd( ), 0 );    
    ReleaseFFdevice( );
	
}

void CDirInputTesterDlg::OnTimer(UINT nIDEvent) 
{
	TCHAR       strText[128]; // Device state text
	TCHAR*      str;
	POINT point;
	point = GetXYStatus( );
	wsprintf( strText, TEXT("%ld"), point.x ); 
	(GetDlgItem(IDC_X_AXIS))->SetWindowText(strText);
	wsprintf( strText, TEXT("%ld"), point.y ); 
	(GetDlgItem(IDC_Y_AXIS))->SetWindowText(strText);
	point = GetABStatus( );
	wsprintf( strText, TEXT("%ld"), point.x ); 
	(GetDlgItem(IDC_A_AXIS))->SetWindowText(strText);
	wsprintf( strText, TEXT("%ld"), point.y ); 
	(GetDlgItem(IDC_B_AXIS))->SetWindowText(strText);
	wsprintf( strText, TEXT("%ld"), (int)GetSliderStatus( ) ); 
    (GetDlgItem(IDC_SLIDER))->SetWindowText(strText);
	
	switch (GetPOVswitchStatus( ))
	{
	case NILL:
		(GetDlgItem(IDC_POV))->SetWindowText("NILL");
		break;
	case NORTH:
		(GetDlgItem(IDC_POV))->SetWindowText("NORTH");
		break;
	case NORTHEAST:
		(GetDlgItem(IDC_POV))->SetWindowText("NORTHEAST");
		break;
	case EAST:
		(GetDlgItem(IDC_POV))->SetWindowText("EAST");
		break;
	case SOUTHEAST:
		(GetDlgItem(IDC_POV))->SetWindowText("SOUTHEAST");
		break;
	case SOUTH:
		(GetDlgItem(IDC_POV))->SetWindowText("SOUTH");
		break;
	case SOUTHWEST:
		(GetDlgItem(IDC_POV))->SetWindowText("SOUTHWEST");
		break;
	case WEST:
		(GetDlgItem(IDC_POV))->SetWindowText("WEST");
		break;
	case NORTHWEST:
		(GetDlgItem(IDC_POV))->SetWindowText("NORTHWEST");
		break;
	default:
		(GetDlgItem(IDC_POV))->SetWindowText("n/a");
	}

	
	// Fill up text with which buttons are pressed
    str = strText;
    for( int i = 1; i < 12; i++ )
    {
        if ( ButtonPressed(i) )
            str += wsprintf( str, TEXT("%02d "), i );
    }
    *str = 0;   // Terminate the string 
	
	(GetDlgItem(IDC_BUTTONS))->SetWindowText(strText);


}

void CDirInputTesterDlg::OnStartForce() 
{
	StartPeriodicForce( );
	AlterPeriodicForce(myMagnitudeSlider.GetPos( ),((double)myPeriodSlider.GetPos( ))/100,myOffsetSlider.GetPos( ),myPhaseSlider.GetPos( ));
}

void CDirInputTesterDlg::OnStopForce() 
{
	StopPeriodicForce( );	
}


void CDirInputTesterDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	TCHAR       strText[128]; // Device state text
	wsprintf( strText, TEXT("%ld"), myMagnitudeSlider.GetPos( ) ); 
	(GetDlgItem(IDC_SLIDER_VAL))->SetWindowText(strText);
	wsprintf( strText, TEXT("%ld"), myPhaseSlider.GetPos( ) ); 
	(GetDlgItem(IDC_PHASE_VAL))->SetWindowText(strText);
	
	//Convert double value from period slider to CString;
	CString strValue;
	double dValue= 0.01*(double)myPeriodSlider.GetPos( );
	strValue.Format("%.2f",dValue);

	(GetDlgItem(IDC_PERIOD_VAL))->SetWindowText(strValue);
	wsprintf( strText, TEXT("%ld"), myOffsetSlider.GetPos( ) ); 
	(GetDlgItem(IDC_OFFSET_VAL))->SetWindowText(strText);
	AlterPeriodicForce(myMagnitudeSlider.GetPos( ),((double)myPeriodSlider.GetPos( ))/100,myOffsetSlider.GetPos( ),myPhaseSlider.GetPos( ));
	if(JOYSTICK == GetDeviceType( ) && IS_CONSTANT){
		AlterConstantForce(myOffsetSlider.GetPos( ),myPhaseSlider.GetPos( ));
	}
}

void CDirInputTesterDlg::OnConstForce() 
{
	IS_CONSTANT = TRUE;   //indicated that constant force is on
	StartConstantForce( );
	AlterConstantForce(myOffsetSlider.GetPos( ),myPhaseSlider.GetPos( ));
}

void CDirInputTesterDlg::OnStopCForce() 
{
	IS_CONSTANT = FALSE;  //indicate that constant force is off
	StopConstantForce( );
	
}


